/***************************************************************************
                          kmessage.h  -  description
                             -------------------
    begin                : Wed Mar 12 15:17:24 CET 2003
    copyright            : (C) 2003 by Jeroen Wijnhout
    email                : wijnhout@science.uva.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMESSAGE_H
#define KMESSAGE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <kpushbutton.h>

#include <qwidget.h>
#include <qcursor.h>
#include <qtextedit.h>

#define DEFAULT_BUTTON "okay"

//contains all information needed to
//display the message
struct KMessageData {
  QString message, file;
  QString buttons, deflt;
  int timeout,width,height;
  bool  nearmouse,center,print,butset;
};

//a slightly expanded version of KPushButton
//this button passes its text and button number to
//the clickedAt signal when it is clicked on
class KMessageButton : public KPushButton {
  Q_OBJECT
  public:
    KMessageButton(QString,int,QWidget *parent, const char *name=0);

  signals:
    void clickedAt(const QString &, int);

  private slots:
    void receive();

  private:
    int number;
};

/** KMessage is the base class of the project */
class KMessage : public QWidget
{
  Q_OBJECT 
  public:
    /** construtor */
    KMessage(const KMessageData *, QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KMessage();

  private slots:
    virtual void polish();
    void handleButton(const QString &, int);

  public slots:
    virtual void show();
     
  private:
    void retrieveMessage();
    
  public:
    void getReady();
      
  private:
    KMessageData kmd;
    KMessageButton *dbutton;
    QTextEdit * mes;
     
    
};



#endif
